-- Exemplo 8 - Flip-Flop D - Testbench
-- Arquitetura de Computadores
-- Prof. Erivelton
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use ieee.std_logic_textio.all;
use std.textio.all;
use ieee.numeric_std.all;
 
entity tb_FFD is
end tb_FFD;
 
architecture behavior of tb_FFD is 
	-- Declaração de componente de: Unit Uder Test (UUT)
component FFD 
	port(clock, rst, D: in std_logic;
		 Q : out std_logic);
end component;
	signal clk              : std_logic;
	signal rst              : std_logic;
	signal data_ain         : std_logic;
	signal Qout      : std_logic;
    signal read_data_in1   : std_logic:='0'; 
    file   inputs_data_in1 : text open read_mode  is "Data_A.txt";
	-- Clock period definitions
	constant period     : time := 20 ns;
	constant duty_cycle : real := 0.5;
	constant offset     : time := 5 ns;

	begin
	-- Definição the Unit Under Test (UUT)
	DUT: FFD 
    port map
		(clock => clk,
		rst => rst,
		D => data_ain,
		Q => Qout);
        process    -- process for clock
        begin
            wait for offset;
            clock_loop : loop
                clk <= '0';
                wait for (period - (period * duty_cycle));
                clk <= '1';
                wait for (period * duty_cycle);
            end loop clock_loop;
        end process;
	sreset: process -- process for reset
	begin
		rst <= '1';
		for i in 1 to 6 loop
			wait until rising_edge(clk);
		end loop;
		rst <= '0'; 
		wait;	
	end process sreset;

	read_inputs_data_ain:process -- process for reading the file
		variable linea : line;
		variable input : std_logic;
		begin
			wait until falling_edge(clk);
			while not endfile(inputs_data_in1) loop
				if read_data_in1 = '1' then
					readline(inputs_data_in1,linea);
					read(linea,input);
					data_ain <= input;
				end if;
			wait for PERIOD;
		end loop;
		wait;
	end process read_inputs_data_ain;	

   tb_stimulus_a : process -- input process
   begin
        wait for (offset + 2*period);
            read_data_in1 <= '1';		
			for i in 1 to 8 loop
		        wait for period;
		    end loop;
            read_data_in1 <= '0';		
		wait;
   end process tb_stimulus_a;	
   
end;
